N=5*36;%% total element number is 180
t=linspace(0,4*pi,N+1); %% node number in the centerline direction is 181
xt = -5* sin(t); % radius 10
yt = t/pi*5;
zt = 5*cos(t);
plot3(xt,yt,zt,'o')
axis equal
xlim([-5,5])
zlim([-5,5])
xlabel('x')
ylabel('y')
zlabel('z')
%view(0,90) % xy plane
distance=sqrt((xt(2:end)-xt(1:end-1)).^2+(yt(2:end)-yt(1:end-1)).^2+(zt(2:end)-zt(1:end-1)).^2);
direction_x=(xt(2:end)-xt(1:end-1))./distance;
direction_y=(yt(2:end)-yt(1:end-1))./distance;
direction_z=(zt(2:end)-zt(1:end-1))./distance;
%% magnetization profile
Mag_magnitude=128000; %% magnetization_magnitude=128 kA/m (20 vol%)
fid=fopen('magetization_profile.txt','w');
for i=1:N
 fprintf(fid, 'mag_x%d=%d\n', i,direction_x(i)*Mag_magnitude);
 fprintf(fid, 'mag_y%d=%d\n', i,direction_y(i)*Mag_magnitude);
 fprintf(fid, 'mag_z%d=%d\n',i,direction_z(i)*Mag_magnitude);
end

%% magnetic  element set
fid1=fopen('element_set.txt','w');
for i=1:N
 fprintf(fid1, '*Elset,elset=mag_set%d,generate\n', i);
 fprintf(fid1, '%d,%d,%d\n', (i-1)*12+1,(i-1)*12+12,1);
end

%% assign magnetic element set with magnetization 
fid2=fopen('mag_property.txt','w');
for i=1:N
 fprintf(fid2, '*uel property,elset=mag_set%d\n', i);
 fprintf(fid2, '<Gshear>,<Kbulk>,<mag_x%d>,<mag_y%d>,<mag_z%d>,<nInt>\n',i,i,i);
end
%% dummy element set , to double check the magnetic element set are assigned properly
fid3=fopen('dummy_element_set.txt','w');
for i=1:N
 fprintf(fid3, '*Elset,elset=dummy_mag_set%d,generate\n', i);
 fprintf(fid3, '%d,%d,%d\n', 10000+(i-1)*12+1,10000+(i-1)*12+12,1);
end